from http.client import responses
from .endpoints import endpoints
from datetime import datetime, timedelta
import sys
import json
import base64
import requests
import logging
_logger = logging.getLogger(__name__)


class credentials:
    mode = None
    credentials = {}
    grant_type = 'client_credentials'
    token_expires_at = None
    token = None    

    def __init__(self):
        self.credentials['api_key'] = None
        self.credentials['access_key'] = None
        self.credentials['client_id'] = None

    def set_api_key(self, api_key):
        self.credentials['api_key'] = api_key

    def set_access_key(self, access_key):
        self.credentials['access_key'] = access_key

    def set_client_id(self, client_id):
        self.credentials['client_id'] = client_id

    def auth(self):
        _endpoints = endpoints()
        authorization = self.get_authorization()
        _url = str()
        _logger.warning('self.mode')
        _logger.warning(self.mode)
        if(str(self.mode)==str('sandbox')):
            _url = str(_endpoints._urls['sandbox_auth']) + \
                str('?grant_type=') + str(self.grant_type)
        else:
            _url = str(_endpoints._urls['production_auth']) + \
                str('?grant_type=') + str(self.grant_type)

        _logger.warning('BG auth *********************************')
        _logger.warning('requesting...')
        _logger.warning(_url)
        _logger.warning(authorization)

        _headers = {}
        _headers['Authorization'] = authorization
        _headers['Accept'] = 'application/json'
        _headers['Content-Type'] = 'application/x-www-form-urlencoded'

        _logger.warning(_headers)
        _logger.warning('EOF auth ********************************')

        response = requests.post(url=_url, headers=_headers)
        response = json.loads(response.text)

        _logger.warning('BG auth response *********************************')
        _logger.warning(response)
        _logger.warning('EOF auth response ********************************')

        self.token_expires_at = datetime.now()

        _logger.warning(
            'BG auth token_expires_at BG 001 *********************************')
        _logger.warning(self.token_expires_at)

        self.token_expires_at = self.token_expires_at + \
            timedelta(seconds=response['expires_in'])

        _logger.warning(
            'BG auth token_expires_at EOF 002 *********************************')
        _logger.warning(self.token_expires_at)

        return response

    def get_authorization(self):
        _string = str(self.credentials['client_id']) + \
            str(':') + str(self.credentials['access_key'])
        _logger.warning('BG _string----------')
        _logger.warning(_string)
        _logger.warning('EOF _string---------')
        _encoded = 'Basic {}'.format(base64.b64encode(
            str(_string).encode('utf-8')).decode())
        _logger.warning('BG _encoded----------')
        _logger.warning(_encoded)
        _logger.warning('EOF _encoded---------')
        return _encoded

    def is_valid_token(self):
        try:
            if(self.token_expires_at == None):
                _logger.warning("returning empty token...")
                return None
            elif(datetime.now() < self.token_expires_at):
                _logger.warning("returning token...")
                return self.token_expires_at
            else:
                _logger.warning("returning empty token...")
                return None
        except Exception as e:
            _logger.warning("returning empty token...")
            _logger.error(str('line: ') + str((format(sys.exc_info()[-1].tb_lineno))))
            return None